<html>
<head>
<style type="text/css">
    body
    {
        color: white;
    }
    
    #grid {
        margin: 0 auto;
    }

    #grid td {
        border: 3px solid black;
        -webkit-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        color: black;
        font-size: smaller;
        text-align: center;
    }

    h4 {
        font-family: ProximaNova,-apple-system,BlinkMacSystemFont,Segoe UI,Roboto,Helvetica Neue,Arial,sans-serif;
        font-weight: 700;
        font-size: 14px;
        text-transform: uppercase;
        margin: 6px;
    }

    #grid td.pixel-on {
        border-color: white;
    }

    .container {
        display: flex;
        flex-wrap: wrap;
    }

    img.shape-button {
        width: 40px;
        height: 40px;
        margin: 7px;
    }

    .color-slider {
        margin-left: 10px;
        margin-right: 10px;
        display: inline-block;
    }

    #colorsliders > * {
        vertical-align: middle;
    }

    #sample {
        height: 60px;
        width: 100%;
        display: block;
        margin-top: 10px;
        margin-bottom: 10px;
    }

    button, button#send-with-params {
        width: 100%;
        text-align: center;
        background-color: black;
        color: white;
        font-size: 14pt;
        padding: 10px;
        margin-top: 20px;
    }

    #shape-parameters-container {
        display: none;
    }
</style>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>

<script>
$(document).ready(function() {
    var cp_red, cp_blue, cp_green, colour_style;
    function updateColour()
    {
        cp_red = $("#cp-red").val();
        cp_blue = $("#cp-blue").val();
        cp_green = $("#cp-green").val();
	    $("#cp-red-text").val(cp_red);
        $("#cp-blue-text").val(cp_blue);
        $("#cp-green-text").val(cp_green);
        colour_style =  `rgb(${cp_red}, ${cp_green}, ${cp_blue})`;
        $("#sample").css('background', colour_style);
    }

    updateColour();
    $("#colorsliders").on("input", updateColour);

    let initialGrid = {{ initialGrid }};
    const supportedShapes = {{ supportedShapes }};

    let cellNum = 0;
    for (y = 0; y < initialGrid.length; y++)
    {
        let rowElement = $("<tr></tr>");
        row = initialGrid[y];
        for (x = 0; x < row.length; x++)
        {
            cell_colour = `rgb(${row[x][0]}, ${row[x][1]}, ${row[x][2]})`
            let cell = $(`<td data-x=${x} data-y=${y}>${cellNum}</td>`).css("background", cell_colour);
            if (row[x][0] > 0 || row[x][1] > 0 || row[x][2] > 0)
                cell.addClass("pixel-on");
            rowElement.append(cell);
            cellNum++;
        }
        $("#grid").append(rowElement);
    }

    for (shape in supportedShapes)
    {
        let shapeBtn = $("<img/>");
        shapeBtn.attr("src", "static/" + shape + ".png");
        shapeBtn.attr("alt", shape);
        shapeBtn.data("shape", shape);
        shapeBtn.addClass("shape-button");
        $("#shapes-container").append(shapeBtn);
    }

    $(".shape-button").on("click", function() {
        const shape = $(this).data("shape");
        const paramValues = $("input[name^='shapeParam[").map(
            function() {return $(this).val();}
        ).get();
        const paramContainer = $("#shape-parameters-container");
        if ($(this).attr("id") != "send-with-params" && supportedShapes[shape].length > 0)
        {
            //this shape has arguments we want to show a mini form asking for them
            const fieldset = $("<fieldset class='shape-params'></fieldset>");
            for (let paramNum = 0; paramNum < supportedShapes[shape].length; paramNum++)
            {
                fieldset.append(`
                    <label for=shapeParam[${paramNum}]>${supportedShapes[shape][paramNum]}</label>
                    <input type=number name=shapeParam[${paramNum}] id=shapeParam[${paramNum}]/>
                `);
            }
            paramContainer.find("button").data("shape", shape);
            paramContainer.find("fieldset").replaceWith(fieldset);
            paramContainer.show();
            return;
        }

        paramContainer.hide();

        $.ajax({
            type: "POST",
            dataType: "JSON",
            contentType: "application/json",
            url: "set-illumination-shape",
            data: JSON.stringify({
                "blue": cp_blue,
                "red": cp_red,
                "green": cp_green,
                "custom": null,
                "shape": shape,
                "paramValues": paramValues.length > 0 ? paramValues : null,
                "overwrite": !$("#add-checkbox").is(":checked")
            })
        }).done(function() {
            location.reload();
        });
    });

    $("#off-button").on("click", function() {
        $.ajax({
            type: "POST",
            dataType: "JSON",
            contentType: "application/json",
            url: "set-illumination-shape",
            data: JSON.stringify({
                "blue": 0,
                "red": 0,
                "green": 0,
                "custom": null,
                "shape": "all",
                "saveColor": false,
            })
        }).done(function() {
            location.reload();
        });
    });

    function pixelOff(td)
    {
        let x = td.data("x");
        let y = td.data("y");
        $.ajax({
            type: "POST",
            dataType: "JSON",
            contentType: 'application/json',
            data: JSON.stringify({
                'pixel_x': x,
                'pixel_y': y,
                'red': 0,
                'green': 0,
                'blue': 0
            })
        }).done(function() {
            td.css("background", "rgb(0,0,0)");
            td.data("color", "off");
            td.removeClass("pixel-on");
        });
    }

    $("#grid td").on("click", function() {
        let td = $(this); 
        let x = td.data("x");
        let y = td.data("y");
        if (td.data("color") == colour_style)
            return pixelOff(td);

        $.ajax({
            type: "POST",
            dataType: "JSON",
            contentType: 'application/json',
            data: JSON.stringify({
                'pixel_x': x,
                'pixel_y': y,
                'red': cp_red,
                'green': cp_green,
                'blue': cp_blue
            })
        }).done(function() {
            td.css("background", colour_style);
            td.data("color", colour_style);
            if (cp_red > 0 || cp_green > 0 || cp_blue >0)
                td.addClass("pixel-on");
        });
    });
});
</script>
</head>
<body>
<h3>Set illumination</h3>
<h4>Colour</h4>
<div id="colorsliders-wrapper">
    <fieldset id="colorsliders">
        R
        <input class="color-slider" min=0 max=255 type='range' value='{{ initialRed }}' id='cp-red'/>
        <output class="color-value" id='cp-red-text'></output>
        <br>
        G
        <input class="color-slider" min=0 max=255 type='range' value='{{ initialGreen }}' id='cp-green'/>
        <output class="color-value" id='cp-green-text'></output>
        <br>
        B
        <input class="color-slider" min=0 max=255 type='range' value='{{ initialBlue }}' id='cp-blue'/>
        <output class="color-value" id='cp-blue-text'></output>
        <br>
    </fieldset>
    <span id='sample'></span>
</table>

<h4>Predefined shapes</h4>
Add mode<input id="add-checkbox" type="checkbox"/>
<div class="container" id="shapes-container">
</div>
<div id="shape-parameters-container">
    <b>This shape has parameters:</b>
    <fieldset class="shape-parameters"></fieldset>
    <button id="send-with-params" class="shape-button">Set</button>
</div>
<h4>Custom shape</h4>
<table id='grid'>
</table>
<button id="off-button">OFF</button>
</body>
</html>